/*  ####################################################################### */
/*  Burfiks: bayesian filter for the web                                    */
/*                                                                          */
/*  (c) Copyright 2007, INRIA                                               */
/*                                                                          */
/*  Authors:                                                                */
/*  --------                                                                */
/*  Francesco Zappa Nardelli (INRIA, Rocquencourt)                          */
/*  Patala Arun Kumar (IIT Kanpur)                                          */
/*  Sanchit Garg (IIT Bombay)                                               */
/*  Vidyut Ghosal (IIT Kanpur)                                              */
/*                                                                          */
/*  This file is distributed under the terms of the GNU Public License      */
/*  version 2, http://www.gnu.org/licenses/gpl.txt                          */ 
/*                                                                          */
/*  ####################################################################### */


var debug_active = true;

function debug (s) {
  if (debug_active) dump (s);
}

debug ("burfiks warming up ...\n");/*
var ios = Components.classes["@mozilla.org/network/io-service;1"].getService(Components.interfaces.nsIIOService);
var uri = ios.newURI("http://www.burfiks.com/", null, null);
var cookieSvc=Components.classes["@mozilla.org/cookieService;1"].getService(Components.interfaces.nsICookieService);*/

var prefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
var burfikspref = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService);


// *** state of burfiks
var current_user = -1;			// to store user name
var current_profile = -1;		// to store profile name
var currentTab = 0;			// to store curent tab index
var result;				// to store responses of the various alerts and popups
var links_size=0;			// to store count of links in a page
var new_page = true;			// something to do with multiple windows ... not really sure
var create_profile = false;		// to differentiate between the windows where the new profile was created and where it is only added
var delete_profile = false;		// to differentiate between the windows where the new user was created and where it is only added
var link="";            		// to store url of a link
var target="";          		// to store target of a link
var newlabel="";        		// to store label of a link
var link_rank="";       		// to store rank of a link
var samePage=false;     		// to decide whether to refresh sidebar or not
var linksShown=false;  			// to solve the problem of sendAllLinks being called twice on new tab
var choice_count=0;  			// to store how many links have been selected for ranking
var dump_data="";  			// to store profile database info when requested

// *** connection from the sidebar to the server
var host;				// host on which server is running
var port;				// port on which server is running

// *** parameters for launching polipo and burfiks
var file = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);
var process = Components.classes["@mozilla.org/process/util;1"].createInstance(Components.interfaces.nsIProcess);
var serverPath;				// path of the server binary
var polipoPath;				// path of the polipo binary

// *** parameters for connecting to server
var transportService = Components.classes["@mozilla.org/network/socket-transport-service;1"].getService(Components.interfaces.nsISocketTransportService);
var transport = "not_initialised";
var outstream = "not_initialised";

function connectToServer () {			// establish socket connection to server
    debug ("burfiks: connectToServer\n");

    netscape.security.PrivilegeManager.enablePrivilege('UniversalXPConnect');
    try {
	transport = transportService.createTransport(null,0,host,port,null);
        outstream = transport.openOutputStream(0,0,0);
    } catch (e) {  window.open("connect_fail.xul","connectFailAlert","chrome,width=");dump(e); }
}

var body;
function sendAllLinks () {			// send the links of a page to the server for evaluation
  debug ("burfiks: sendAllLinks\n");
  clearSidebar();

  var win = window.content;
  var doc = win.document;
  var ref = win.location.href;
  body = "LINKS\n" + ref + '\n';

  linksShown = false;
  sendLinksRec (parent.window.frames[currentTab],"");

  body = body + 'END\n';
  try {
    outstream.write (body,body.length,"");
    outstream.flush ();
    dump(body);
  } catch (e) { window.open("connect_fail.xul","connectFailAlert","chrome,width="); }
}

function sendLinksRec (frames, preString) {	// recursively extract links for each frame
  var doc = frames.document;
  var size = doc.links.length;
  var valid_link_count = 0;

  for (var i = 0; i < size; i++)

    if (doc.links[i].protocol == "http:" || doc.links[i].protocol == "https:") {

      var target = preString;
      if (doc.links[i].target == "_content")
	target = preString;
      if (doc.links[i].target == "")
	target = preString;
      else if (doc.links[i].target == "_top")
	target = -1;
      else if (doc.links[i].target == "_parent") {
	target = "";
	targetArray = preString.split(":");
	for (k = 0; k < targetArray.length - 2; k++)
	  target = target + targetArray[k] + ":";
      }
      else if (doc.links[i].target == "_blank")
	target = -1;
      else target = doc.links[i].target;
      
      if (target == "")
	target = "-1";
      
      if( doc.links[i].text)
      {
      valid_link_count = valid_link_count + 1; 
      if (doc.links[i].text.replace(/[\s]+/g,"") == "") body = body + target + ' ' + doc.links[i].href + ' ' + doc.links[i].href + '\n';
      else
	try{
	  tempText = doc.links[i].text.replace(/[\n\r]+/g,"");     
	  body = body + target + ' ' + doc.links[i].href + ' ' + tempText + '\n';
	}catch (e){
	body = body + target + ' ' + doc.links[i].href + ' ' + doc.links[i].href + '\n';
      }
      }
    } 
   
  links_size = valid_link_count+links_size;


  for(var j = 0; j < frames.frames.length; j++) {
    sendLinksRec(frames.frames[j], preString + j + ":");
  }
}

// *** listening for connections from a server, updating accordingly the sidebar

var serverSocket;

function startup () {
  debug ("burfiks: startup\n");
  document.getElementById('new-tree').onselect=selectLink;
  burfikspref = burfikspref.getBranch("burfiks.");
  setOptions();
  setOptionsDisplay();
  if(((document.getElementById('username').value)!="")&&((document.getElementById('password').value)!="")){onLogin();}
}

function listenServerStart () {			// listens to and deals with server responses
  debug ("burfiks: listenServer\n");
  
  try {
    var stream = transport.openInputStream(0,0,0);
    var instream = Components.classes["@mozilla.org/scriptableinputstream;1"].createInstance(Components.interfaces.nsIScriptableInputStream);
    instream.init(stream);
    var dataListener = {
      onStartRequest: function(request, context){},
      onStopRequest: function (request, context, status) {
	    instream.close();
	  },
      onDataAvailable: function (request, context, inputStream, offset, count) {
	    var input_buffer = instream.read (count);
	    var serverResponse = input_buffer.split ("\n");
	    
	    for (k=0;k<serverResponse.length;k++) {
	      var infoarray = serverResponse[k].split (" ");
	      
	      //Login Information sent by the server
	      if (infoarray[0] == "LOGIN_SUCCEED"){
		onValidation();
		document.getElementById("options").hidden = true;
	      }
	      if (infoarray[0] == "LOGIN_FAILED"){
		document.getElementById('password').value="";
		alert("Login Failed");
	      }
	      
	      //Add user
	      if (infoarray[0] == "USER_ADDED") {
		onValidation();
		addFirstProfile();
		document.getElementById("options").hidden = true;
		alert("To view public folders of other users on this server please logout and login again");
	      }
	      if (infoarray[0] == "ADD_USER_FAILED") {
		document.getElementById('password').value="";
		alert("Add User Failed");
	      }
	      if (infoarray[0] == "USER_DELETED") {
                 alert("User Deleted");
		onLogout();
	      }
	      
	      //Logout Information sent by the server	
	      if (infoarray[0] == "LOGOUT_SUCCEED")
		logoutValidation();
	      
	      //Profile added/deleted information	      
	      if (infoarray[0] == "PROFILE_ADDED") {
		var profileName = infoarray[1];
		for (i=2; i< infoarray.length-1; i++)
		  profileName += " " + infoarray[i];
		if(create_profile) {create_profile=false;addProfile(current_user,profileName,"PRIVATE",1);}
		else addProfile(current_user,profileName, "PRIVATE",2);
	      }
	      if (infoarray[0] == "PROFILE_DELETED") {
		var userName = infoarray[1];
		var profileName = infoarray[2];
		for (i=3; i< infoarray.length-1; i++) profileName += " " + infoarray[i];
		var list = document.getElementById('profileMenu');
                var id = userName+"_" + profileName;
                var profile_list = document.getElementById('profileList');
		var item = document.getElementById(id);
		list.removeChild(item);
		if(profile_list.selectedItem.getAttribute("id") == id || profile_list.selectedItem.getAttribute("label")=="Delete profile"){
		autoSelectProfile();}
	      }
	      if (infoarray[0] == "PROFILE_DEL_FAILED") {
		alert("Profile deletion failed");
		cancelDeleteProfile();
	      }   
	      if (infoarray[0] == "PROFILE_ADD_FAILED") {
		alert("Profile adding failed");
		cancelDeleteProfile();
	      }   
	      
	      //Adding existing profiles at login time
	      if (infoarray[0] == "EXISTING_PROFILE") {
		var privacy = infoarray[1];
		var user = infoarray[2];
		var profileName = infoarray[3];
		for (i=4; i< infoarray.length-1; i++)
		profileName += " " + infoarray[i];

		addProfile(user,profileName,privacy,2);
	      }
              
              if (infoarray[0] == "END_EXISTING_PROFILES") {
                autoSelectProfile ();
              }

	      //Choice processed/failed information	      
	      if (infoarray[0] == "CHOICE_PROCESSED") {
		if(infoarray[1]==0) alert("No Page Ranked. Either the server is busy or pages are not acceesible");
		else if (infoarray[1]<choice_count) {
		  alert(infoarray[1]+" out of "+choice_count+" pages ranked");
		  sendAllLinks();
		}
		else sendAllLinks();
		choice_count=0;
              }	

	      //Indicates start of the profile database information	
	      if (infoarray[0] == "DUMP_START") {
		//var browser = top.document.getElementById("content");
		//data_tab = browser.addTab();
		my_window= window.open ("","Info Of"+current_profile,"status=1,width=450,height=650,scrollbars=yes");
		my_window.document.write('<title>Info Of '+current_profile+'</title>');
		my_window.document.write('<TABLE border="1.0"><CAPTION><EM>Database Information</EM></CAPTION>');
		my_window.document.write('<TR><TH>Word<TH># of occurences in good pages<TH># of occurences in bad pages');
	      }

	      if (infoarray[0] == "DUMP") {
		//for (i=1; i< infoarray.length; i++) dump_data += " " + infoarray[i];
		my_window.document.write('<TR><TD>'+infoarray[1]+'<TD>'+infoarray[2]+'<TD>'+infoarray[3]); 
		dump_data = "";
              }

	      if (infoarray[0] == "DUMP_END") {
		my_window.document.close();
                 sendAllLinks();
              }

	      if (infoarray[0] == "DUMP_FAILED") {
		alert("Couldn't process your request at the moment. Please try again");
                 sendAllLinks();
	      }	

	      if (infoarray[0] == "CACHE_SUCCEED") {
		alert("Cache cleared");
                 sendAllLinks();
	      }	

	      if (infoarray[0] == "CACHE_FAILED") {
		alert("Clearing cache failed");
                 sendAllLinks();
	      }			
	      //Profile Selected
	      if (infoarray[0] == "PROFILE_SELECT_DONE"){
		var profileName = infoarray[1];
		for (i=2; i< infoarray.length-1; i++) profileName += " " + infoarray[i];
       	        current_profile = document.getElementById('profileList').selectedItem.getAttribute("id");
                burfikspref.setCharPref("profile",current_profile);
		var label = document.getElementById(current_profile).getAttribute("label");
		var labelArray = label.split("-");
		if (labelArray.length != 1) document.getElementById("share").setAttribute("hidden","true");
		else 
		{
		labelArray = label.split(" ");
		if (labelArray.length != 1)
		{
			document.getElementById("share").setAttribute("hidden","false");
			document.getElementById("share").setAttribute("label","Make Current Profile Private");		
		}	
		else
		{
			document.getElementById("share").setAttribute("hidden","false");
			document.getElementById("share").setAttribute("label","Make Current Profile Public");		
		}
		}
		linksShown=true;
                sendAllLinks();
	      }

	      if (infoarray[0] == "SHARE_SUCCEED") {
		var user = infoarray[1];
		var profileName = infoarray[2];
		if(user==current_user) {
		  document.getElementById(user+"_"+profileName).setAttribute("label",profileName+" (Public)");
                  alert("Profile "+profileName+" Made Public");
		  cancelDeleteProfile();
		  document.getElementById("share").setAttribute("label","Make Current Profile Private");
		  var msg = 'PROFILE_SELECTED\n' + 'PUBLIC\n' + user + '\n' + profileName + '\n';
    		  outstream.write (msg, msg.length);
		  outstream.flush ();
		}
		else addProfile(user,profileName,"PUBLIC",2);
	      }

	      //Sharing of a profile successful
	      if (infoarray[0] == "UNSHARE_SUCCEED") {
		var user = infoarray[1];
		var profileName = infoarray[2];
		if(user==current_user) {
		  document.getElementById(user+"_"+profileName).setAttribute("label",profileName);
		  alert("Profile "+profileName+" Made Private");
		  cancelDeleteProfile();
		  document.getElementById("share").setAttribute("label","Make Current Profile Public");	
		  var msg = 'PROFILE_SELECTED\n' + 'PRIVATE\n' + user + '\n' + profileName + '\n';
    		  outstream.write (msg, msg.length);
		  outstream.flush ();
		}
		else document.getElementById("profileMenu").removeChild(document.getElementById(user+"_"+profileName));
	      }

	      //Sharing of a profile not successful
	      if (infoarray[0] == "SHARE_FAILED") {
		alert("Could not share the current profile. Please try again later");		
	      }
	      
	      //Links sent by the server
	      if (infoarray[0] == "LINKS")
              {
		  samePage = (infoarray[2] == window.content.location.href);
		  var temp_label = infoarray[5]; 
		  for (i=6; i<infoarray.length-1; i++){
                  temp_label = temp_label+" "+infoarray[i];
		  }
		  link=infoarray[4];
		  target=infoarray[3];
		  newlabel=temp_label;
		  link_rank=infoarray[1];
	      }

	      if (infoarray[0] == "KEYS"){
              if(samePage){
                  document.getElementById("actCount").value = document.getElementById("new-treechildren").childNodes.length+1;
		  document.getElementById("totCount").value = links_size;
		var key_words = infoarray[1];
		for (i=2; i< infoarray.length-1; i++) key_words = key_words+" "+infoarray[i];
		addnode(link,target,newlabel,link_rank,key_words);
		}
		samePage=false;
	      }
	    }
	}
    }
    var pump = Components.classes["@mozilla.org/network/input-stream-pump;1"].createInstance(Components.interfaces.nsIInputStreamPump);
    pump.init(stream, -1, -1, 0, 0, false);
    pump.asyncRead(dataListener,null);
  } catch (ex){
      window.open("connect_fail.xul","connectFailAlert","chrome,width=");
  }
  return null;
}

// interaction

function clearSidebar () {				// clears the sidebar of all links
  var ti = document.getElementById('new-treechildren');
  var len = ti.childNodes.length;
  for (i=0; i < len; i++) ti.removeChild(ti.childNodes[0]);
  links_size = 0;
  document.getElementById("actCount").value = "0";
  document.getElementById("totCount").value = "0";
}

function selectLink (event) {				// handles clicking of a link in the sidebar
  debug ("burfiks: selectLink\n");
  
  var tree = document.getElementById('new-tree');
  var Id = tree.view.getCellText(tree.currentIndex,tree.columns['link']);

  var target = tree.view.getCellText(tree.currentIndex,tree.columns['target']);
  if (target==-1) window.parent.frames[currentTab].location = Id;
  else {
    var targetArray = target.split(":");
    if (targetArray.length == 1) selectTarget (window.parent.frames[currentTab].frames, Id, target);
    else {
      var frameLocation=window.parent.frames[currentTab];
      for (var i = 0; i < targetArray.length - 1; i++) frameLocation = frameLocation.frames[targetArray[i]];	    
      frameLocation.location = Id;
    }
  	}
}

function selectTarget (main, Id, target) {
  for (i=0; i < main.length; i++)
    if (main[i].name == target) {
      main[i].location = Id;
      exit();
    } else
      selectTarget (main[i].frames, Id, target);
}

function emptySidebar(event) {				// redundant ... here just for historical reasons
  if (event.attrName == "busy" && event.prevValue == "true")
    clearSidebar = 1;
}

// *** shutdown
function shutdown () {					// close everything nicely
  debug ("burfiks: shutdown\n");
  onLogout ();
  if (serverSocket) serverSocket.close ();
}

// *** login actions and protocol

function addProfile (user,pname,privacy,flag) {		// add existing profile to the menu list in sidebar
  var separator1 = document.getElementById('menuSeparator1');
  var separator2 = document.getElementById('menuSeparator2');
  var item = document.createElement("menuitem");
  var id = user + "_" + pname;
  item.setAttribute("id",id);
  item.setAttribute("oncommand","profileSelected()");

  if(user==current_user)
  {
    if(privacy=="PRIVATE") item.setAttribute("label",pname);
    if(privacy=="PUBLIC") item.setAttribute("label",pname+" (Public)");
    document.getElementById('profileMenu').insertBefore(item,separator1);
  }
  else
  {
    item.setAttribute("label",pname+" - "+user);
    document.getElementById('profileMenu').insertBefore(item,separator2);
  }

  if (flag == 1) {
    var list = document.getElementById('profileList');
    list.selectedItem = item;
    profileSelected();    // was item
  }
}

function onLogin () {				// handle user login
  debug ("burfiks: onLogin\n");
  var user = document.getElementById("username").value;
  var password = document.getElementById("password").value;
  onLogin2 (user,password);
}


function onLogin2 (user,password) {
  saveOptions();
  host = document.getElementById("serverhost").value;
  port = document.getElementById("serverport").value;
  current_user = user;
  document.getElementById('logout').setAttribute("label","Logout "+user);
  if(!document.getElementById('advance').selected)
  {
	runServer();
	var i=0;
	for (i;i<9999999;i++);
        connectToServer();
        listenServerStart ();
  }
  else
  {
        connectToServer();
        listenServerStart ();
	alert("You selected advanced mode");
  }	
  
  var login_msg = 'LOGIN\n'+user+'\n'+password+'\n';
  try {
    outstream.write (login_msg, login_msg.length);
    outstream.flush ();
  } catch(e) {
    alert("Could Not Connect to Server. Please try again");
  }
}

function autoSelectProfile () {
  debug ("burfiks: autoSelectProfile\n");
  var profile_list = document.getElementById('profileList');
  var no_profiles = profile_list.firstChild.childNodes.length - 10;
  debug("Number of items "+profile_list.firstChild.childNodes.length+"\n");
  if (no_profiles == 0) addFirstProfile();
  else {
    var firstProfile = profile_list.firstChild.childNodes[0];
    profile_list.selectedItem = firstProfile;
    profileSelected();    // was firstProfile
  }
}

function addUser () {
  var password2 = document.getElementById("password2").value;
  self.close();
  current_user = window.opener.document.getElementById("username").value;
  var password = window.opener.document.getElementById("password").value;
  host = window.opener.document.getElementById("serverhost").value;
  port = window.opener.document.getElementById("serverport").value;
  
  var checkOK = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";
  var allValid = true;
  for (i = 0;  i < password.length;  i++)
  {
  for (j = 0;  j < checkOK.length;  j++)
  if (password.charAt(i) == checkOK.charAt(j))
  break;
  if (j == checkOK.length)
  {
  allValid = false;
  alert("Please enter only letter and numeric characters in the password field.");
  break;
  }
  }

  if (password.length < 3 && allValid)
  {
  alert("Please enter at least 3 characters in the password field.");
  allValid = false;
  }

  if (password!=password2 && allValid)
  {
  alert("Sorry, you typed different passwords");
  allValid = false;
  }

  if (allValid) {
    if(!window.opener.document.getElementById('advance').selected)
    {
	window.opener.runServer();
	var i=0;
	for (i;i<9999999;i++);
	window.opener.connectToServer();
	window.opener.listenServerStart ();
    }
    else
    {
        window.opener.connectToServer();
        window.opener.listenServerStart ();
    }
    try {	
      var login_msg = 'ADDUSER\n'+current_user+'\n'+password+'\n';
      window.opener.outstream.write(login_msg, login_msg.length);
      window.opener.outstream.flush();
    } catch(e) {
      alert("Could Not Connect to Server. Please try again");
    }
  }
}

function deleteUser() {
  var msg = 'DELETEUSER\n';
  outstream.write(msg, msg.length);
  outstream.flush();
}

function confirmDeleteUser() {
  window.opener.deleteUser();
  self.close();
}

function confirmPassword() {
  debug ("burfiks: addUser\n");

  var password2 = document.getElementById("password2").value;
  self.close();
  window.opener.addUser(password2);
}
    
var pageLoad = {
 QueryInterface: function(aIID) {
    if (aIID.equals(Components.interfaces.nsIWebProgressListener) ||
	aIID.equals(Components.interfaces.nsISupportsWeakReference) ||
	aIID.equals(Components.interfaces.nsISupports))
      return this;
    throw Components.results.NS_NOINTERFACE;
  },
 
 onLocationChange: function(aProgress, aRequest, aURI) {
    clearSidebar();
    new_page = true;
    var tabbrowser = parent.getBrowser();
    var newTab = tabbrowser.mTabContainer.selectedIndex;
    if (newTab >= 1) newTab++;
    if (currentTab!=newTab && linksShown==false) {
      currentTab =  newTab;
      sendAllLinks();
    }
  },
 
 onStateChange: function(aProgress, aRequest, state, flag) {
    if ((state == 786448 || state == 17563664) && new_page){
      new_page = false;
      sendAllLinks();
    }
  },

 onProgressChange : function(a,b,c,d,e,f){},
 onStatusChange : function(a,b,c,d){},
 onSecurityChange : function(a,b,c){},
 onLinkIconAvailable : function(a){} 
};

function onValidation () {
  debug ("burfiks: onValidation\n");
  document.getElementById('tabbox').hidden = true;
  document.getElementById('login-window1').hidden = true;
  document.getElementById('btoolbar').hidden = false; 
  parent.gBrowser.addProgressListener(pageLoad);
  var tabbrowser = parent.getBrowser();
  var newTab = tabbrowser.mTabContainer.selectedIndex;
  if (newTab >= 1) newTab++;
  currentTab =  newTab;
} 
 
// *** logout actions and protocol

function onLogout () {
  debug ("burfiks: logout\n");
  if(current_user != -1) { 
    var logout_msg = 'LOGOUT\n';
    outstream.write(logout_msg, logout_msg.length);
    outstream.flush();
  }
}

function onLogoutAll () {
  debug ("burfiks: logout\n");
  if(current_user != -1) {
    if (!(burfikspref.getBoolPref("rempasswd")))
    {
    burfikspref.setCharPref('username',"");
    burfikspref.setCharPref('password',"");
   }
    var logout_msg = 'LOGOUT_ALL\n';
    outstream.write(logout_msg, logout_msg.length);
    outstream.flush();
  }
}

function logoutValidation () {
  debug ("burfiks: logout Validated\n");
  setOptions();
  document.getElementById('btoolbar').hidden = true;
  document.getElementById('tabbox').hidden = false;
  document.getElementById('login-window1').hidden = false;
  current_user = -1;
  current_profile = -1;

  parent.gBrowser.removeProgressListener(pageLoad);
  document.getElementById("options").hidden = false;

  var list = document.getElementById('profileList');
  var blank = list.firstChild.childNodes;
  var number = blank.length;
  for (i = 1; i < number-9; i++)
    list.removeItemAt(0);
  var item = document.createElement("menuseparator");
  item.setAttribute("id","menuSeparator1");
  var separator = document.getElementById('menuSeparator2');
  document.getElementById('profileMenu').insertBefore(item,separator);
  clearSidebar();
}

function createProfile (profileName) {
  var i;
  var exist = 0;
  var list = document.getElementById('profileList');
  var blank = list.firstChild.childNodes;
  var number = blank.length;
  for (i = 0; i < number-9; i++)
    if (blank[i].getAttribute("label") == profileName) exist = 1;

  if (exist == 0)
  {

    var checkOK = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";
    var allValid = true;
    for (i = 0;  i < profileName.length;  i++)
    {
	for (j = 0;  j < checkOK.length;  j++)
	  if (profileName.charAt(i) == checkOK.charAt(j))
	    break;
	if (j == checkOK.length)
	{
	  allValid = false;
	  alert("There should be no spaces or special characters in the profile name.");
	  cancelDeleteProfile();
	  break;
        }
    }
    if(allValid)
    {
	var profileMsg = 'CREATEPROFILE\n'+profileName+'\n';
	create_profile = true;
	outstream.write(profileMsg, profileMsg.length);
	outstream.flush();
    }
  }
  else 
  {
    alert("Profile adding failed .. Same name already exists");
    cancelDeleteProfile();
  }
}

function getProfileName () {
  var name = document.getElementById("profileName").value;
  window.opener.createProfile(name);
  self.close();
}

function deleteProfile () {
  var nameArray = current_profile.split("_");
  var label = document.getElementById(current_profile).getAttribute("label");
  var labelArray = label.split("-");
  if(labelArray.length == 1)
  {
    var labelArray = label.split(" ");
    if(labelArray.length == 1) var msg = 'DELETEPROFILE\n'+'PRIVATE\n'+nameArray[1]+'\n';
    else var msg = 'DELETEPROFILE\n'+'PUBLIC\n'+nameArray[1]+'\n';
    outstream.write(msg, msg.length);
    outstream.flush();
  }
  else alert("You cannot delete other user's profiles");
  cancelDeleteProfile();
}

function cancelDeleteProfile () {
  document.getElementById('profileList').selectedItem = document.getElementById(current_profile);
}
        
function profileSelected () {
  var selectedValue = document.getElementById('profileList').selectedItem.getAttribute("id");
  var idArray = selectedValue.split ("_");

  if(current_profile != selectedValue)
  {
    var label = document.getElementById('profileList').selectedItem.getAttribute("label");
    var labelArray = label.split("-");
    if(labelArray.length!=1) var msg = 'PROFILE_SELECTED\n' + 'PUBLIC\n' + idArray[0] + '\n' + idArray[1] + '\n';
    else
    {
	labelArray = label.split(" ");
	if(labelArray.length!=1) var msg = 'PROFILE_SELECTED\n' + 'PUBLIC\n' + idArray[0] + '\n' + idArray[1] + '\n';
	else var msg = 'PROFILE_SELECTED\n' + 'PRIVATE\n' + idArray[0] + '\n' + idArray[1] + '\n';
    }    
    outstream.write(msg, msg.length);
    outstream.flush();
  }
}

function classifierB (argument) {
  debug ("burfiks : classifying the link\n"+parent.frames[currentTab].location+"\n");
  var ti = document.getElementById('new-treechildren');
  var msg = argument + '\n';
  var check=0;
  for (i=0; i < ti.childNodes.length; i++) {
    var temp = ti.childNodes[i];
    temp = temp.childNodes[0];
    if (temp.childNodes[0].getAttribute("value")=="true") {
      msg = msg + temp.childNodes[2].getAttribute("label")+'\n';
      choice_count++;	
      check = 1;
    }
  }
  if (check==0) {msg = msg + parent.frames[currentTab].location + '\n' + 'END\n';choice_count++;}
  else msg = msg + 'END\n';
  outstream.write(msg, msg.length);
  outstream.flush();
}

function burfiksHelp() {
  window.parent.frames[currentTab].location="http://moscova.inria.fr/~zappa/software/burfiks";
  cancelDeleteProfile();
}

function addFirstProfile() {
   result = prompt("Create a Profile:");
   if (result == null) addFirstProfile();
   else createProfile(result);
}

function addProfilePrompt() {
   result = prompt("Create a Profile:");
   if (result == null) cancelDeleteProfile();
   else createProfile(result);
}

function deleteProfilePrompt() {
   result = confirm("Are you sure you want to delete the current profile?");
   if (result) deleteProfile();
   else cancelDeleteProfile();     
}

function deleteUserPrompt() {
   result = confirm("Are you sure you want to delete this user account?");
   if (result) deleteUser();
   else cancelDeleteProfile();     
}

function runServer() {
try {

// *** stores the user preference directory in PrefD
var nsip = Components.classes["@mozilla.org/file/directory_service;1"].getService(Components.interfaces.nsIProperties);
var extDir = nsip.get("PrefD", Components.interfaces.nsIFile); 

// *** create the path to the burfiks_server binary
serverPath = extDir.clone();
serverPath.append("extensions")
serverPath.append("linux_burfiks@moscova.inria.fr");
serverPath.append("chrome");
serverPath.append("content");
serverPath.append("burfiks_server");

// *** create the path to the polipo binary
polipoPath = extDir.clone();
polipoPath.append("extensions"); 
polipoPath.append("linux_burfiks@moscova.inria.fr");
polipoPath.append("chrome");
polipoPath.append("content");
polipoPath.append("polipo");

file.initWithPath(serverPath.path); 

// polipoPath = "/home/yquem/moscova/ghosal/Desktop/burfiks/server/polipo/polipo";
// file.initWithPath("/home/yquem/moscova/ghosal/Desktop/burfiks/server/burfiks_server");
process.init(file);

/*if(prefs.getIntPref("network.proxy.type")==1) {
  var host = prefs.getCharPref("network.proxy.http");
  var port = prefs.getIntPref("network.proxy.http_port");
  var args = ["-polipo_bin",polipoPath,"-debug_all","-normal_mode","true","-proxy_running_at",host+":"+port];
  process.run(false, args, 7);
}
*/
if(document.getElementById('proxysel').checked)
{
  var host = document.getElementById('proxyhost').value;
  var port = document.getElementById('proxyport').value;
  if(document.getElementById('pauth').checked)
  {
    var puser = document.getElementById('puser').value;
    var ppass = document.getElementById('ppass').value;
    var args = ["-polipo_bin",polipoPath.path,"-debug_all","-normal_mode","-parent_proxy",host+":"+port,"-proxy_auth",puser+":"+ppass];
    process.run(false, args, 8);
  }
  else 
  {
    var args = ["-polipo_bin",polipoPath.path,"-debug_all","-normal_mode","-parent_proxy",host+":"+port];
    process.run(false, args, 6);
  }
}
else {
  var args = ["-polipo_bin",polipoPath.path,"-debug_all","-normal_mode"];
  process.run(false, args, 4);
}
}
catch (e) {
dump(e);
alert("There is problem in launching the server. Please try again");}
}


function addnode(link,target,label,rank, word) {
      var titem = document.createElement("treeitem");
      titem.setAttribute("container", "true");
      var trow = document.createElement("treerow");
      if (rank==101) {trow.setAttribute('properties', 'lite0');}

      tcell = document.createElement("treecell");
      trow.appendChild(tcell);

      var tcell = document.createElement("treecell");
      tcell.setAttribute("label", label);
      trow.appendChild(tcell);

      tcell = document.createElement("treecell");
      tcell.setAttribute("label", link);
      trow.appendChild(tcell);

      tcell = document.createElement("treecell");
      tcell.setAttribute("label", target);
      trow.appendChild(tcell);

      tcell = document.createElement("treecell");
      tcell.setAttribute("label", rank);
      trow.appendChild(tcell);

// Creating tree child for displaying keywords,rank and URL

      var tchild = document.createElement("treechildren");

// Keyword
      var titem1 = document.createElement("treeitem");

      var trow1 = document.createElement("treerow");

      tcell = document.createElement("treecell");
      tcell.setAttribute("disabled", "true");
      trow1.appendChild(tcell); 

      tcell = document.createElement("treecell");
      tcell.setAttribute("label", "Keywords- "+word);
      trow1.appendChild(tcell);

      titem1.appendChild(trow1);
      tchild.appendChild(titem1); 

// Rank

      titem1 = document.createElement("treeitem");

      trow1 = document.createElement("treerow");

      tcell = document.createElement("treecell");
      tcell.setAttribute("label", "Relevance percentage - "+(100-rank));
      trow1.appendChild(tcell);

      tcell = document.createElement("treecell");
      tcell.setAttribute("label", "Relevance percentage - "+(100-rank));
      trow1.appendChild(tcell);

      titem1.appendChild(trow1);
      tchild.appendChild(titem1); 

// URL

      titem1 = document.createElement("treeitem");

      trow1 = document.createElement("treerow");

      tcell = document.createElement("treecell");
      tcell.setAttribute("label", link);
      trow1.appendChild(tcell);

      tcell = document.createElement("treecell");
      tcell.setAttribute("label", link);
      trow1.appendChild(tcell);

      titem1.appendChild(trow1);
      tchild.appendChild(titem1); 

// Finally apend row and its child to the tree

      titem.appendChild(trow);
      titem.appendChild(tchild);


      var ti = document.getElementById('new-treechildren');
      var i = 0;
      var found = 0;
      for (i=0; i < ti.childNodes.length; i++) {
	var temp = ti.childNodes[i];
	temp = temp.childNodes[0];
	temp = temp.childNodes[4];	
	if (parseInt(rank) < parseInt(temp.getAttribute("label"))) {
		ti.insertBefore(titem ,temp.parentNode.parentNode);
		found = 1;
	}
	if (found==1) break;
      }
      
       if (found==0) ti.appendChild(titem);


}

function share() {
  var nameArray = current_profile.split("_");
  var label = document.getElementById(current_profile).getAttribute("label");
  var labelArray = label.split("-");
  if(labelArray.length == 1)
  {
    var labelArray = label.split(" ");
    if(labelArray.length == 1) {
      var msg = 'SHARE\n'+nameArray[1]+'\n';
      outstream.write(msg, msg.length);
      outstream.flush();
    }
    else {
      var msg = 'UNSHARE\n'+nameArray[1]+'\n';
      outstream.write(msg, msg.length);
      outstream.flush();   
    }   	
  }
  else alert("You cannot share other user's profiles");

}  

function dumpDb() {
  var msg = 'DUMP\n';
  outstream.write(msg, msg.length);
  outstream.flush();  
  cancelDeleteProfile();
}

function clearCache() {
  var msg = 'CLEAR_CACHE\n';
  outstream.write(msg, msg.length);
  outstream.flush();  
  cancelDeleteProfile();
}

function advanced() {
  if(document.getElementById('advance').selected == true)
  {
	document.getElementById('serverhost').disabled = false;
	document.getElementById('serverport').disabled = false;
	document.getElementById('proxysel').disabled = true;
	document.getElementById('pauth').disabled = true;
	document.getElementById('proxyhost').disabled = true;
	document.getElementById('proxyport').disabled = true;
	document.getElementById('puser').disabled = true;
	document.getElementById('ppass').disabled = true;
  }
  else 
  {
	document.getElementById('serverhost').disabled = true;
	document.getElementById('serverport').disabled = true;
	document.getElementById('proxysel').disabled = false;
	document.getElementById('pauth').disabled = false;
	if(document.getElementById('proxysel').checked == true)
        {
	  document.getElementById('proxyhost').disabled = false;
	  document.getElementById('proxyport').disabled = false;
        }
	if(document.getElementById('pauth').checked == true)
        {
	  document.getElementById('puser').disabled = false;
	  document.getElementById('ppass').disabled = false;
        }
  }
}

function authenticate() {
  if(document.getElementById('pauth').checked == true)
  {
	document.getElementById('puser').disabled = false;
	document.getElementById('ppass').disabled = false;
  }
  else 
  {
	document.getElementById('puser').disabled = true;
	document.getElementById('ppass').disabled = true;
  }
}

function setproxy() {
  if(document.getElementById('proxysel').checked == true)
  {
	document.getElementById('proxyhost').disabled = false;
	document.getElementById('proxyport').disabled = false;
  }
  else 
  {
	document.getElementById('proxyhost').disabled = true;
	document.getElementById('proxyport').disabled = true;
  }
}

function saveOptions() {
  burfikspref.setCharPref('username',document.getElementById('username').value);
  burfikspref.setCharPref('password',document.getElementById('password').value);
  burfikspref.setBoolPref('rempasswd',document.getElementById('rempasswd').checked);
  burfikspref.setBoolPref('useProxy',document.getElementById('proxysel').checked);
  burfikspref.setIntPref('useServer',document.getElementById('mode').selectedIndex);
  burfikspref.setCharPref('shost',document.getElementById('serverhost').value);
  burfikspref.setIntPref('sport',document.getElementById('serverport').value);
  burfikspref.setCharPref('phost',document.getElementById('proxyhost').value);
  burfikspref.setIntPref('pport',document.getElementById('proxyport').value);
  burfikspref.setCharPref('puser',document.getElementById('puser').value);  
  burfikspref.setCharPref('ppasswd',document.getElementById('ppass').value);
  burfikspref.setBoolPref('useAuth',document.getElementById('pauth').checked);
}

function setDefault() {
  document.getElementById('username').value="";
  document.getElementById('password').value="";
  document.getElementById('proxysel').checked = false;
  document.getElementById('rempasswd').checked = true;
  document.getElementById('mode').selectedIndex = 0;
  document.getElementById('serverhost').value = "localhost";
  document.getElementById('serverport').value = "7056";
  if(prefs.getIntPref("network.proxy.type")==1) {
    document.getElementById('proxyhost').value = prefs.getCharPref("network.proxy.http");
    document.getElementById('proxyport').value = prefs.getIntPref("network.proxy.http_port");
  }
  else {
    document.getElementById('proxyhost').value = "localhost";
    document.getElementById('proxyport').value = "8123";
  }
  document.getElementById('puser').value = "none";  
  document.getElementById('ppass').value = "none";
  document.getElementById('pauth').checked = false;

  saveOptions();
}

function setOptionsDisplay () {
  setproxy();
  authenticate();
  advanced();
}

function setOptions() {
  document.getElementById('username').value = burfikspref.getCharPref('username');
  document.getElementById('password').value = burfikspref.getCharPref('password');
  document.getElementById('rempasswd').checked = burfikspref.getBoolPref('rempasswd');
  document.getElementById('proxysel').checked = burfikspref.getBoolPref('useProxy');
  document.getElementById('mode').selectedIndex = burfikspref.getIntPref('useServer');
  document.getElementById('serverhost').value = burfikspref.getCharPref('shost');
  document.getElementById('serverport').value = burfikspref.getIntPref('sport');
  document.getElementById('proxyhost').value = burfikspref.getCharPref('phost');
  document.getElementById('proxyport').value = burfikspref.getIntPref('pport');
  document.getElementById('puser').value = burfikspref.getCharPref('puser');  
  document.getElementById('ppass').value = burfikspref.getCharPref('ppasswd');
  document.getElementById('pauth').checked = burfikspref.getBoolPref('useAuth');
}
